#ifndef __ATP_ENV_H_
#define __ATP_ENV_H_

/*******************************************************************************
 *
 * atp_env.h
 *
 * This files contains external definitions and prototypes for ATP environment
 * module.
 *
 * (C) Texas Instruments, all rights reserved
 *
 * Version number	: 1.0
 *
 * History			: 1.0 (2/21/2000) - Created
 *
 * Date             : 30/May/2000
 *
 * Author           : Eric Baissus : e-baissus@ti.com
 *
 ******************************************************************************/
#include "rv/rv_general.h"
#include "rvf/rvf_api.h"
#include "rvm/rvm_gen.h"


T_RVM_RETURN atp_get_info (T_RVM_INFO_SWE *p_info_swe);

T_RVM_RETURN
atp_set_info(T_RVF_ADDR_ID addr_id,
             T_RV_RETURN   return_path[],
             T_RVF_MB_ID   mb_id[],
             T_RVM_RETURN  (*rvm_error_ft) ( T_RVM_NAME swe_name,
                                             T_RVM_RETURN error_cause,
                                             T_RVM_ERROR_TYPE error_type,
                                             T_RVM_STRING error_msg) );
T_RVM_RETURN atp_init (void);

T_RVM_RETURN atp_start (void);

T_RVM_RETURN atp_stop (void);

T_RVM_RETURN atp_kill (void);



#endif
