/********************************************************************************/
/*                                                                              */
/*   File Name:   dar_test_regr.h                                               */
/*                                                                              */
/*   Purpose:   This file contains the definition usefull for a dar             */
/*                  non regression test.                                        */
/*                                                                              */
/*   Note:    None.                                                             */
/*                                                                              */
/*   Version    0.1                                                             */
/*                                                                              */
/*   Date               Modification                                            */
/*   -------------------------------------------------------------------------- */
/*   27 september   Create                                                      */
/*                                                                              */
/*   Author      Stephanie Gerthoux                                             */
/*                                                                              */
/* (C) Copyright 2001 by Texas Instruments Incorporated, All Rights Reserved    */
/********************************************************************************/

#ifndef _DAR_TEST_REGR_H_
   #define _DAR_TEST_REGR_H_

#include "tests/rv/rv_test_filter_redirect.h"
   #include "tests/rv/rv_test_regr.h"

   #if (DAR_REGR == SW_COMPILED)

      /* Define paramters, functions and macros used tto ferform miscellaneous DAR tests */

	   T_RV_REGR_RET dar_regr_test_1 (T_RV_REGR_ERR_TYPE *error_type);
	   T_RV_REGR_RET dar_regr_test_2 (T_RV_REGR_ERR_TYPE *error_type);
	   T_RV_REGR_RET dar_regr_test_3 (T_RV_REGR_ERR_TYPE *error_type);
	   T_RV_REGR_RET dar_regr_test_4 (T_RV_REGR_ERR_TYPE *error_type);
	   T_RV_REGR_RET dar_regr_test_5 (T_RV_REGR_ERR_TYPE *error_type);
	   T_RV_REGR_RET dar_regr_test_6 (T_RV_REGR_ERR_TYPE *error_type);
	   T_RV_REGR_RET dar_regr_test_7 (T_RV_REGR_ERR_TYPE *error_type);
	   T_RV_REGR_RET dar_regr_test_8 (T_RV_REGR_ERR_TYPE *error_type);
	   T_RV_REGR_RET dar_regr_test_9 (T_RV_REGR_ERR_TYPE *error_type);
	   T_RV_REGR_RET dar_regr_test_10 (T_RV_REGR_ERR_TYPE *error_type);
	   T_RV_REGR_RET dar_regr_test_11 (T_RV_REGR_ERR_TYPE *error_type);
	   T_RV_REGR_RET dar_regr_test_12 (T_RV_REGR_ERR_TYPE *error_type);
	   T_RV_REGR_RET dar_regr_test_13 (T_RV_REGR_ERR_TYPE *error_type);
	   T_RV_REGR_RET dar_regr_test_14 (T_RV_REGR_ERR_TYPE *error_type);
	   T_RV_REGR_RET dar_regr_test_15 (T_RV_REGR_ERR_TYPE *error_type);
	   T_RV_REGR_RET dar_regr_test_16 (T_RV_REGR_ERR_TYPE *error_type);
	   T_RV_REGR_RET dar_regr_test_17 (T_RV_REGR_ERR_TYPE *error_type);
	   T_RV_REGR_RET dar_regr_test_18 (T_RV_REGR_ERR_TYPE *error_type);
	   T_RV_REGR_RET dar_regr_test_19 (T_RV_REGR_ERR_TYPE *error_type);
	   T_RV_REGR_RET dar_regr_test_20 (T_RV_REGR_ERR_TYPE *error_type);
	   T_RV_REGR_RET dar_regr_test_21 (T_RV_REGR_ERR_TYPE *error_type);
	   T_RV_REGR_RET dar_regr_test_22 (T_RV_REGR_ERR_TYPE *error_type);
	   T_RV_REGR_RET dar_regr_test_23 (T_RV_REGR_ERR_TYPE *error_type);
	   T_RV_REGR_RET dar_regr_test_24 (T_RV_REGR_ERR_TYPE *error_type);

	   T_RV_RET trace_dar_test_verdict ( T_RV_TEST_RET   test_verdict, 
	 									 T_RV_REGR_TEST_TOT nb_of_test_in_list, 
										 T_RV_REGR_TEST_TOT nb_of_test_succeeded, 
										 T_RV_REGR_ERR_TYPE *error_type);

   #endif /* #if (DAR_REGR == SW_COMPILED) */
#endif