/*******************************************************************************
 *
 * OPTBOOT.H
 *
 * This module contains functions which build a confirmation for each option:
 *  - get the chip id,
 *  - get the monitor id,
 *  - get the board_id.
 *
 * (C) Texas Instruments 1999
 *
 ******************************************************************************/

#ifndef __OPTBOOT_H__
#define __OPTBOOT_H__

#include "command.h"


extern void opt_get_monitor_id (t_com_request *request,
                                t_com_confirmation *confirmation);

extern void
opt_load_application (t_com_request *request, t_com_confirmation *confirmation, SYS_UWORD8 device_id);

extern unsigned long
opt_get_running_address (t_com_request *request, t_com_confirmation *confirmation);


#endif /* __OPTBOOT_H__ */
