/* 
+----------------------------------------------------------------------------- 
|  Project :  
|  Modul   :  
+----------------------------------------------------------------------------- 
|  Copyright 2002 Texas Instruments Berlin, AG 
|                 All rights reserved. 
| 
|                 This file is confidential and a trade secret of Texas 
|                 Instruments Berlin, AG 
|                 The receipt of or possession of this file does not convey 
|                 any rights to reproduce or disclose its contents or to 
|                 manufacture, use, or sell anything it may describe, in 
|                 whole, or in part, without the specific written consent of 
|                 Texas Instruments Berlin, AG. 
+----------------------------------------------------------------------------- 
|  Purpose :  Driver Table for G23
+----------------------------------------------------------------------------- 
*/ 

#ifndef __GSMDRV_C__
#define __GSMDRV_C__
#endif

#ifndef NEW_ENTITY
#define NEW_ENTITY
#endif

/*==== INCLUDES ===================================================*/


#ifdef _TARGET_
 #define TI_TRACE
#endif


#include "gdi.h"
#include "vsi.h"
#include "pei.h"
#include "frm_defs.h"
#include "gsmconst.h"
#include "frm_types.h"

/*#include "gdi.h"
#include "pei.h"
#include "gsmconst.h"
//#include "frmconst.h"
#include "frm_defs.h"
#include "frm_types.h"*/

/*==== TYPES ======================================================*/


/*==== CONSTANTS ==================================================*/

#if defined _TARGET_ && !defined PCON
 #define TR_RCV_BUF_SIZE    1024
#else
 #define TR_RCV_BUF_SIZE    1024
#endif

#define TR_MAX_IND         (TR_RCV_BUF_SIZE-1)

/*==== EXTERNALS ==================================================*/

#ifdef TI_TRACE
extern USHORT TIF_Init ( USHORT DrvHandle, T_DRV_CB_FUNC CallbackFunc,
                         T_DRV_EXPORT const **DrvInfo );
extern USHORT TR_Init  ( USHORT DrvHandle, T_DRV_CB_FUNC CallbackFunc,
                         T_DRV_EXPORT const **DrvInfo );
extern USHORT TITRC_Init ( USHORT DrvHandle, T_DRV_CB_FUNC CallbackFunc,
                         T_DRV_EXPORT const **DrvInfo );
#else

extern USHORT TIF_Init ( USHORT DrvHandle, T_DRV_CB_FUNC CallbackFunc, 
                         T_DRV_EXPORT const **DrvInfo );
extern USHORT TR_Init  ( USHORT DrvHandle, T_DRV_CB_FUNC CallbackFunc, 
                         T_DRV_EXPORT const **DrvInfo );
extern USHORT SER_Init ( USHORT DrvHandle, T_DRV_CB_FUNC CallbackFunc, 
                         T_DRV_EXPORT const **DrvInfo );
extern ULONG SER_DefaultConfig;
#endif

/*==== VARIABLES ==================================================*/

ULONG TR_RcvBufferSize = TR_RCV_BUF_SIZE;
ULONG TR_MaxInd = TR_MAX_IND;

const T_DRV_LIST_ENTRY DrvList[] = 
{
  { NULL,  NULL,     NULL,  NULL },
#ifdef TI_TRACE
  { "TIF",  TIF_Init, "RCV", "ENABLE_PCON" },
  { "TR",   TR_Init,  NULL,  NULL },
  { "TITRC",TITRC_Init,   NULL,  "" },
#else
  { "TIF", TIF_Init, "RCV", "ENABLE_PCON" },
  { "TR",  TR_Init,  NULL,  NULL },
  { "SER", SER_Init, NULL,  "" },
#endif
  { NULL,  NULL,     NULL,  NULL }
};

/*==== FUNCTIONS ==================================================*/


int vsi_o_trace (char *caller, ULONG tclass, char *text,...)
{
  return 0;
}
