/*
  +------------------------------------------------------------------------------
  |  File:       alr_steps.h
  +------------------------------------------------------------------------------
  |              Copyright 2003 Texas Instruments
  |              All rights reserved.
  |
  |              This file is confidential and a trade secret of Texas Instruments.
  |              The receipt of or possession of this file does not convey
  |              any rights to reproduce or disclose its contents or to
  |              manufacture, use, or sell anything it may describe, in
  |              whole, or in part, without the specific written consent of
  |              Texas Instruments.
  +------------------------------------------------------------------------------
  | Purpose:     Contains prototype steps for alr
  |
  +------------------------------------------------------------------------------
*/
#ifndef ALR_STEPS_H
#define ALR_STEPS_H

/*Prototypes*/

T_STEP filter_and_routings_gsm_900__alr000                               ();
T_STEP initiation_by_rr_4_channels_available_alr001                      ();
T_STEP initiation_by_rr_8_channels_available_alr002                      ();
T_STEP find_bcch_carrier_first_channel_alr003                            ();
T_STEP configuring_ms_for_idle_mode_and_meas                             ();
T_STEP find_bcch_carrier_first_channel_failed_then_second_channel_alr004 ();
T_STEP find_bcch_carrier_second_channel_alr006                           ();
T_STEP read_bcch_data_alr007                                             ();
T_STEP rr_rejects_bcch_carrier_try_third_channel_alr009                  ();
T_STEP rr_rejects_bcch_carrier_try_fourth_channel_alr010                 ();
T_STEP rr_select_second_channel_alr012                                   (CHAR variant);
T_STEP rr_select_first_channel_alr013                                    ();
T_STEP initiation_with_paging_reorganisation_alr020                      (CHAR variant);
T_STEP page_mode_change_paging_reorganisation_alr022                     (CHAR variant);
T_STEP page_mode_change_back_to_normal_paging_alr025                     ();
T_STEP page_mode_change_normal_paging_alr026                             (CHAR variant);
T_STEP page_mode_change_extended_paging_a_second_time_alr027             (CHAR variant);
T_STEP measurement_reporting_configuration_alr030                        (CHAR variant);
T_STEP measurement_reporting_configuration_alr9806                       ();
T_STEP definition_of_bcch_allocation_alr046                              (CHAR variant);
T_STEP start_of_sending_channel_request_messages_gsm_900__alr055         ();
T_STEP immediate_assignment_for_the_mobile_station_alr056                ();
T_STEP extended_measurement_reporting_start_procedure_alr062             ();
T_STEP extended_measurement_reporting_successful_power_measurement_alr063();
T_STEP paging_req_1_imsi_tmsi_for_ms_alr071                              (CHAR variant);
T_STEP paging_req_1_not_for_ms_alr072                                    (CHAR variant);
T_STEP paging_req_1_short_imsi_tmsi_for_ms_alr073                        (CHAR variant);
T_STEP paging_req_2_tmsi_for_ms_mobile_identity_1_or_2__alr075           (CHAR variant);
T_STEP paging_req_2_imsi_tmsi_for_ms_mobile_identity_3__alr077           (CHAR variant);
T_STEP paging_req_2_short_imsi_tmsi_for_ms_mobile_identity_3__alr078     (CHAR variant);
T_STEP paging_req_3_tmsi_for_ms_alr080                                   (CHAR variant);
T_STEP find_bcch_carrier_second_channel_alr088                           ();
T_STEP read_bcch_data_alr091                                             ();
T_STEP rr_rejects_bcch_carrier_try_fourth_channel_alr094                 ();
T_STEP handover_serving_cell_parameter_alr154                            (CHAR variant);
T_STEP neighbour_cell_in_dedicated_alr155                                ();
T_STEP neighbour_cell_after_ho_alr156                                    ();
T_STEP filter_and_routings_dcs_1800__alr200                              ();
T_STEP initiation_by_rr_4_channels_available_alr201                      ();
T_STEP find_bcch_carrier_first_channel_alr203                            ();
T_STEP find_bcch_carrier_first_channel_failed_then_second_channel_alr204 ();
T_STEP find_bcch_carrier_second_channel_alr206                           ();
T_STEP read_bcch_data_alr207                                             ();
T_STEP rr_rejects_bcch_carrier_try_third_channel_alr209                  ();
T_STEP rr_rejects_bcch_carrier_try_fourth_channel_alr210                 ();
T_STEP rr_select_second_channel_alr212                                   (CHAR variant);
T_STEP filter_and_routings_dualband_gsm_900_dcs_1800__alr600             ();
T_STEP initiation_by_rr_8_channels_available_alr601                      ();
T_STEP find_bcch_carrier_first_channel_alr603                            ();
T_STEP find_bcch_carrier_last_channel_alr603                             ();
T_STEP find_bcch_carrier_first_channel_failed_then_second_channel_alr604 ();
T_STEP find_bcch_carrier_second_channel_alr606                           ();
T_STEP read_bcch_data_alr607                                             ();
T_STEP rr_select_second_channel_alr612                                   (CHAR variant);
T_STEP configuration_cbch_followed_by_mmi_request_alr800                 (CHAR variant);
T_STEP mmi_request_followed_by_configuration_of_cbch_alr801              (CHAR variant);
T_STEP reception_of_expected_cbch_message_alr803                         (CHAR variant);
T_STEP reception_of_cbch_schedule_message_alr809(CHAR variant);
T_STEP power_measurement_e_otd_on_idle_mode__alr960                      ();
T_STEP connection_established_e_otd_dedicated_mode__alr970               ();
T_STEP e_otd_measurement_started_dedicated_mode__alr972                  (CHAR variant);
T_STEP rr_select_first_channel_alr013_gprs                               ();
T_STEP sending_error_data_in_sacch                                       ();
T_STEP generating_six_sync_failures                                      ();
T_STEP pdch_assignment_alrg007                                           ();
T_STEP rr_select_first_channel_gprs_pbcch                                (T_VAR_NMO var);
T_STEP abort_search_due_to_mo_call                                       (T_VAR_ABORT_PLMN_SEARCH var);
T_STEP abort_search_due_to_leaving_pim                                   (T_VAR_ABORT_PLMN_SEARCH var);
T_STEP abort_search_due_to_cell_resel                                    (T_VAR_ABORT_PLMN_SEARCH var);
T_STEP nc_pbcch_initial_sync                                             ();
T_STEP abort_search_due_to_cell_sel                                      (T_VAR_ABORT_PLMN_SEARCH var);
T_STEP start_of_sending_channel_request_messages_gsm_900__alr9803();
T_STEP rr_cell_selection_emr (char idle_var,char rxlev_var,char emr_var );
T_STEP initial_setting_state_to_dedicated();
T_STEP continue_page_mode_reorg_after_hplnm_search_procedure             (CHAR variant);
T_STEP stop_page_mode_reorg_before_hplnm_search_procedure                ();
T_STEP meas_ind_with_start_sync_followed_by_rach_procedure                 ();
T_STEP measurement_reporting_configuration_nwctrl                        (CHAR variant);
T_STEP rxlevel_measurement_based_on_search_parallel                      (CHAR search_mode, CHAR rxlev_idx);
T_STEP rxlevel_measurement_based_on_search_quadband                      (CHAR search_mode, CHAR rxlev_idx, CHAR pchinterrupt);
T_STEP rxlevel_measurement_based_on_search_american                      (CHAR search_mode, CHAR band, CHAR rxlev_idx);
#include "alr_ncell_steps.h"

#endif
