
/*=============================================================================
 *     Copyright Texas Instruments 2002. All Rights Reserved.
 */


/*=============================================================================
    Description:
    This test is derived from the TestCase base class.

    Args:
    logWriter        -  A writer object that is used to log any messages.
                        User can either pass in a writer object or null.

    warningWriter    -  A writer object that is used to log any warning messages.
                        User can either pass in a writer object or null.

    errorWriter      -  A writer object that is used to log any error messages
                        User can either pass in a writer object or null.

    Returns:
    n/a

 */
public function IntegTestTemplate( logWriter, warningWriter, errorWriter )
  extends pkg.esf.obstest.util.IntegTestObstest(
      "esf.obstest.IntegTestTemplate"
    , logWriter
    , warningWriter
    , errorWriter
    )
{
  //====================================================================================
  /**
    @param rctx         the routing context to use for traffic
    @param scriptEhId   the event handler id to spoof for this test case
    @param agePkg       a package to use for age event handler convenience ops
    @param obsPkg       a package to use for obs event handler convenience ops
    @param obstestPkg   a package to use for obstest event handler convenience
    @param evList       a list into which events from the aggregate stream are
                        placed.
   */
  function runIntegTestObstest(
        rctx
      , scriptEhId
      , agePkg
      , obsPkg
      , obstestPkg
      , evList
    )
  {
    logInfo( "This is just the template for tests, not an actual test!!" );
    return;
  }

}




